package main

import "fmt"


type PossiedeDistOrigine interface {
	DistOrigine() float64
}
// Sia Point che Line soddisfano quest'interfaccia

func calcolaDistMediaDaOrigine(lista []PossiedeDistOrigine) float64 {
	sum := 0.0
	for _, x := range lista {
		sum += x.DistOrigine()
	}
	return sum / float64(len(lista))
}

func main() {
	var p, q Point
	p = NewPoint(1, 3.5)
	q = NewPoint(4, -7)
	fmt.Println(p, q)
	fmt.Println(p.DistOrigine())
	fmt.Println(p.Dist(q))    // q.Dist(p)

	var r Line
	r = p.RettaPassante(q)
	fmt.Println(r)
	fmt.Println(r.PassaPer(p))
	fmt.Println(r.DistOrigine())

	var lista []PossiedeDistOrigine
	lista = append(lista, NewPoint(3, 4))
	lista = append(lista, NewPoint(-1, 5))
	lista = append(lista, NewLine(1.5, 7))

	fmt.Println(calcolaDistMediaDaOrigine(lista))




}
