package main

import "fmt"

type Line struct {
	m, q float64
}

func NewLine(m,q float64) Line {
	return Line{m,q}
}

func LineString(r Line) string {
	return fmt.Sprintf("y=%.3f * x + %.3f", r.m, r.q)
}

func RettaPassante(p1, p2 Point) Line {
	m := (p2.y - p1.y) / (p2.x - p1.x)
	q := p1.y - m * p1.x
	return NewLine(m, q)
}

func PassaPer(Line r, Point p) bool {
	return p.y == r.m * p.x + r.q
}